﻿Type=Activity
Version=2.52
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim nSelectedItem As Int
	Dim m_CurrentTab As Int
	Dim CurrentPatterns As List
	Dim ActivePatterns As List
	Dim GarmentTypes As List
	' my user defined types
	Type PatternInfo(Yarn As String, Garment As String, Image As String, Sizes As String, Item_Description As String, location As String, Active As Boolean)
	'Type ActivePatterns( Int MainPatternIndex )	
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	'''''''''''''''''''''''''''''''''''''''''''''''''''''
	' definitions for Controls
	Dim ImageView1 As ImageView
	Dim TabHost1 As TabHost
	Dim ListView1 As ListView
	Dim ScrollView1 As ScrollView
	Dim Panel1 As Panel
	'''''''''''''''''''''''''''''''''''''''''''''''''''''
	' from sample code
	Type ExpListViewItem(IsParent As Boolean, Expanded As Boolean, id As Int, childto As Int, itemtxt As String)
	Dim ExpandableList As List
	''''''''''''''''''''''''''''''''''''''''''''''''''''''
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	' define colors for tabs.
	' load the main layupt file
	Activity.LoadLayout("selection_screen")
	'initialise the lists
	GarmentTypes.Initialize
	ActivePatterns.Initialize
	CurrentPatterns.Initialize

	' add the tabs and layouts to the tabhost
	TabHost1.AddTab("Active","active_projects")
	TabHost1.AddTab("Patterns","available_patterns")
	TabHost1.AddTab("Options","options")
	' sorts the layout files to size correctly on the tabs'
	SortTabs
	
	UpdateDisplay
	' force the selected item image
	DisplayGarmentImage(0)
	
	'builds the unique garment list
	GetGarmentList
	'creates the patterns list for the scrollview.
	CreatePatternsList
	'Draw the list
	DrawListView
End Sub

Sub Activity_Resume
	'TODO
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	'TODO
End Sub

Sub ListView1_ItemClick (Position As Int, Value As Object)
	'change the garment image to the selected item.
	DisplayGarmentImage(Position)
End Sub
Sub DisplayGarmentImage (Position As Int)
	' display the image for the selected item. this is tab dependant.
	If TabHost1.CurrentTab  = 1 Then
		Dim p As PatternInfo 
		Dim bmp As Bitmap
		p = CurrentPatterns.Get(Position)
		bmp.Initialize(p.location, p.Image)
		ImageView1.Bitmap = bmp
		nSelectedItem = Position
	Else If TabHost1.CurrentTab = 0 Then
		Dim p As PatternInfo
		Dim AP As List
		Dim bmp As Bitmap
		AP = GetActiveProjectList
		If AP.Size >0 Then
			p = CurrentPatterns.Get(AP.Get(Position))
			bmp.Initialize(p.location, p.Image)
			ImageView1.Bitmap = bmp
			nSelectedItem = AP.Get(Position)
		End If
	Else
		' no image yet, as this is the options/setup tab
		ImageView1.Background = Null
	End If
End Sub

Sub UpdateDisplay
	CurrentPatterns.Initialize ' initialise the list object
	FindPatterns
	PopulateDisplayList
	'DisplayGarmentImage(0)
	
End Sub

Sub ImageView1_Click
	' start new activity - load selected pattern
	StartActivity("MainPattern")
End Sub

Sub PopulateDisplayList
	Dim ndx As Int	
	Dim p As PatternInfo
	Dim M As Int
	If TabHost1.CurrentTab  = 1 Then
		M = CurrentPatterns.Size -1
		For ndx = 0 To M
			p = CurrentPatterns.Get(ndx)
		Next	
	Else If TabHost1.CurrentTab = 0 Then
		ListView1.Clear
		Dim AL As List
		AL = GetActiveProjectList
		M = AL.Size -1
		For ndx = 0 To M
			p = CurrentPatterns.Get(AL.Get(ndx))
			ListView1.AddSingleLine(p.Item_Description)
		Next	
	Else
	' Handle the options screen
	End If
End Sub


Sub FindPatterns
	Dim Directory As String
	Dim DS As List
	Dim ndx As Int
	Dim m As Int
	Directory = File.DirRootExternal & "/knitting patterns"
	DS = File.ListFiles(Directory)
	m = DS.Size-1
	For ndx = 0 To m
		ProcessPattern(DS.Get(ndx))
	Next
End Sub

Sub ProcessPattern( location As String )
	Dim thisfilelocation As String
	Dim filecontent As List
	Dim ndx As Int
	thisfilelocation = File.DirRootExternal & "/Knitting Patterns/" & location
	filecontent = File.ReadList(thisfilelocation,"knitting_pattern.KBP")
	ProcessAndAddSinglePattern(filecontent, thisfilelocation)
End Sub

Sub ProcessAndAddSinglePattern( item As List, location As String)
	Dim p As PatternInfo
	p.Initialize
	p.Yarn = item.Get(0)
	p.Garment = item.Get(1)
	p.Image = item.Get(2)
	p.Sizes = item.Get(3)
	p.Item_Description = item.Get(4)
	p.Active = IsProjectActive(location)
	p.location = location
	CurrentPatterns.Add(p)
End Sub

' this finds all of the active work and returns a list of the index's in the main list
Sub GetActiveProjectList() As List
	Dim ret As List
	Dim temp As PatternInfo
	ret.Initialize
	Dim ndx As Int
	For ndx = 0 To CurrentPatterns.Size-1
		temp = CurrentPatterns.Get(ndx)
		If temp.Active = True Then			
			ret.Add(ndx)
		End If
	Next
	Return ret
End Sub

Sub IsProjectActive ( location As String) As Boolean
	Dim ret As Boolean
	ret = False 'assume project is inactive
		If File.Exists(location, "active.PAT") Then
			ret = True
		End If
	Return ret
End Sub
Sub TabHost1_TabChanged
	'TODO
End Sub

' organises the controls onto the tabs
Sub SortTabs
	TabHost1.Color = Colors.Black
	ListView1.left = TabHost1.Left
	ListView1.width = TabHost1.Width
	ListView1.Height = 100%x
	ScrollView1.Left = TabHost1.Left
	ScrollView1.Width = TabHost1.Width
	ScrollView1.Height = 100%x
'	ScrollView1.Panel.Height = 1000dip
	Panel1.Left = TabHost1.Left
	Panel1.Width = TabHost1.width
	Panel1.Height = 100%x
End Sub
Sub ScrollView1_ScrollChanged(Position As Int)
	'ScrollView1.ScrollPosition = Position
End Sub

Sub CreatePatternsList
	ExpandableList.Initialize 
	Dim pi As PatternInfo
	For i = 0 To GarmentTypes.Size-1
		Dim parentItem As ExpListViewItem 
		parentItem.Initialize 
		parentItem.Expanded = False
		parentItem.id = i
		parentItem.childto = -1
		parentItem.IsParent = True
		parentItem.itemtxt = GarmentTypes.Get(i)
		ExpandableList.Add(parentItem)
		For j = 0 To CurrentPatterns.Size-1
			Dim item As ExpListViewItem 
  		item.Initialize 
			item.IsParent = False
			item.Expanded = False
			'item.id = i * 100 + j
			item.id = j
			item.childto = parentItem.id 
			pi = CurrentPatterns.Get(j)
			If pi.Garment = GarmentTypes.Get(i) Then
				item.itemtxt = pi.Item_Description 
				ExpandableList.Add(item)
			End If
		Next
	Next
End Sub

'Create a custom layout for the panel here. It may also be dependent on the item
Sub ConstructPanel(item As ExpListViewItem,p As Panel)
	Dim l As Label 
	Dim img As ImageView 
	
	l.Initialize("")
	img.Initialize("")
	
	'sv.Panel.AddView(p,0,
	p.AddView(l,48dip,0dip,400dip,40dip)
	p.AddView(img,4dip,2dip,32dip,32dip)
	l.Gravity = Gravity.CENTER_VERTICAL 
	l.TextSize = 20
	Dim c As Canvas 
	c.Initialize(p)
	c.DrawLine(0,p.Height-2dip,100%x,p.Height-2dip,Colors.Gray,1dip)
	
	l.Text = item.itemtxt
	If item.IsParent = True AND item.Expanded = True Then
		img.Bitmap = LoadBitmap(File.DirAssets,"ic_menu_less.png")
	Else If item.IsParent = True Then
		img.Bitmap = LoadBitmap(File.DirAssets,"ic_menu_more.png")
	End If
	p.Tag = item

End Sub


'Draw the list here. There is only 1 level of hierarchy
Sub DrawListView
	'Clear scrollview
	For i = ScrollView1.Panel.NumberOfViews-1 To 0 Step -1
		ScrollView1.Panel.RemoveViewAt(i)
	Next
	
	Dim ItemHeight As Int 
	ItemHeight = 40dip
	Dim ChildOffset As Int 
	ChildOffset = 15dip
	
	Dim pHeight As Int 
	pHeight = 0

	For i = 0 To ExpandableList.Size-1
		Dim item As ExpListViewItem 
		item = ExpandableList.Get(i)
		If item.IsParent = True Then
			Dim p As Panel 
			p.Initialize("pnl")
			ScrollView1.Panel.AddView(p,0,pHeight,100%x,ItemHeight)
			ConstructPanel(item,p)
			pHeight = pHeight + ItemHeight
		End If
		If item.Expanded=True Then
			For j = 0 To ExpandableList.Size-1 
				Dim childitem As ExpListViewItem 
				childitem = ExpandableList.Get(j)
				If childitem.childto = item.id Then
					Dim p As Panel 
					p.Initialize("pnl")
					ScrollView1.Panel.AddView(p,ChildOffset,pHeight,100%x-ChildOffset ,ItemHeight)
					ConstructPanel(childitem,p)
					pHeight = pHeight + ItemHeight
				End If
			Next
		End If
	Next
	ScrollView1.Panel.Height = pHeight
End Sub

'Deal with Panel click. All controls are clickable
Sub pnl_Click
	Dim v As View
	v = Sender
	Dim item As ExpListViewItem 
	item = v.Tag
	If item.IsParent = True Then
		item.Expanded = Not(item.Expanded)
		DrawListView
	Else
		' set selected pattern to the item id..
		DisplayGarmentImage(item.id)
	End If
End Sub


Sub GetGarmentList
	Dim pi As PatternInfo
	Dim reptxt As String
	Dim ndx As Int
	For ndx = 0 To CurrentPatterns.Size-1
		pi = CurrentPatterns.Get(ndx)
		If IsGarmentInList(pi.Garment) = False Then
			GarmentTypes.Add(pi.Garment)
			reptxt = "adding garment " & pi.Garment & " to list"
			Log(reptxt)
		End If
	Next
End Sub

Sub IsGarmentInList(item As String) As Boolean
	Dim ndx As Int
	For ndx = 0 To GarmentTypes.Size-1
		If GarmentTypes.Get(ndx) = item Then
			Return True ' do it this way to be quick.
		End If
	Next
	Return False
End Sub